<?php
/*
Plugin Name: Wptuts+ Countdowner
Plugin URI: TODO
Description: A widget to display a countdown timer in your site's sidebar.
Version: 1.0
Author: Japh
Author URI: http://wp.tutsplus.com/author/Japh
Text Domain: wptuts-countdowner-locale
Domain Path: /lang/
Network: false
License: GPLv2 or later
License URI: http://www.gnu.org/licenses/gpl-2.0.html

Copyright 2013 Japh

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as 
published by the Free Software Foundation.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// TODO: change 'Wptuts_Countdowner' to the name of your plugin
class Wptuts_Countdowner extends WP_Widget {

	/*--------------------------------------------------*/
	/* Constructor
	/*--------------------------------------------------*/
	
	/**
	 * Specifies the classname and description, instantiates the widget, 
	 * loads localization files, and includes necessary stylesheets and JavaScript.
	 */
	public function __construct() {
	
		// load plugin text domain
		add_action( 'init', array( $this, 'widget_textdomain' ) );
		
		// Hooks fired when the Widget is activated and deactivated
		register_activation_hook( __FILE__, array( $this, 'activate' ) );
		register_deactivation_hook( __FILE__, array( $this, 'deactivate' ) );
		
		// TODO:	update classname and description
		// TODO:	replace 'wptuts-countdowner-locale' to be named more plugin specific. Other instances exist throughout the code, too.
		parent::__construct(
			'wptuts-countdowner-id',
			__( 'Wptuts+ Countdowner', 'wptuts-countdowner-locale' ),
			array(
				'classname'		=>	'wptuts-countdowner-class',
				'description'	=>	__( "A widget to display a countdown timer in your site's sidebar.", 'wptuts-countdowner-locale' )
			)
		);
		
		// Register admin styles and scripts
		add_action( 'admin_print_styles', array( $this, 'register_admin_styles' ) );
		add_action( 'admin_enqueue_scripts', array( $this, 'register_admin_scripts' ) );
	
		// Register site styles and scripts
		add_action( 'wp_enqueue_scripts', array( $this, 'register_widget_styles' ) );
		add_action( 'wp_enqueue_scripts', array( $this, 'register_widget_scripts' ) );

	} // end constructor

	/*--------------------------------------------------*/
	/* Widget API Functions
	/*--------------------------------------------------*/
	
	/**
	 * Outputs the content of the widget.
	 *
	 * @param	array	args		The array of form elements
	 * @param	array	instance	The current instance of the widget
	 */
	public function widget( $args, $instance ) {
	
		extract( $args, EXTR_SKIP );

		echo $before_widget;
    
		// TODO:	Here is where you manipulate your widget's values based on their input fields

		$event = apply_filters( 'wptuts_countdowner_event', $instance['event'] );
		$event_date = apply_filters( 'wptuts_countdowner_event_date', $instance['event_date'] );

		$event_date_seconds = date( 'U', strtotime( $event_date ) );
		$today_date_seconds = date( 'U' );

		$event_date = human_time_diff( $event_date_seconds );
		$suffix = ( $event_date_seconds > $today_date_seconds ? 'away' : 'ago' );

		include( plugin_dir_path( __FILE__ ) . '/views/widget.php' );
		
		echo $after_widget;

	} // end widget
	
	/**
	 * Processes the widget's options to be saved.
	 *
	 * @param	array	new_instance	The previous instance of values before the update.
	 * @param	array	old_instance	The new instance of values to be generated via the update.
	 */
	public function update( $new_instance, $old_instance ) {
	
		$instance = $old_instance;
		
		// TODO:	Here is where you update your widget's old values with the new, incoming values
		$instance['event'] = strip_tags( $new_instance['event'] );
		$instance['event_date'] = strip_tags( $new_instance['event_date'] );
    
		return $instance;
		
	} // end widget
	
	/**
	 * Generates the administration form for the widget.
	 *
	 * @param	array	instance	The array of keys and values for the widget.
	 */
	public function form( $instance ) {
	
    	// TODO:	Define default values for your variables
		$instance = wp_parse_args(
			(array) $instance
		);
	
		// TODO:	Store the values of the widget in their own variable
		if ( ! empty( $instance['event'] ) ) {
			$event = $instance['event'];
		}
		else {
			$event = __( 'Event Name', 'wptuts-countdowner-locale' );
		}

		if ( ! empty( $instance['event_date'] ) ) {
			$event_date = $instance['event_date'];
		}
		else {
			$event_date = date( 'Y-m-d' );
		}
		
		// Display the admin form
		include( plugin_dir_path(__FILE__) . '/views/admin.php' );	
		
	} // end form

	/*--------------------------------------------------*/
	/* Public Functions
	/*--------------------------------------------------*/
	
	/**
	 * Loads the Widget's text domain for localization and translation.
	 */
	public function widget_textdomain() {
	
		// TODO be sure to change 'wptuts-countdowner' to the name of *your* plugin
		load_plugin_textdomain( 'wptuts-countdowner-locale', false, plugin_dir_path( __FILE__ ) . '/lang/' );
		
	} // end widget_textdomain
	
	/**
	 * Registers and enqueues admin-specific styles.
	 */
	public function register_admin_styles() {
	
		// TODO:	Change 'wptuts-countdowner' to the name of your plugin
		wp_enqueue_style( 'wp-admin-jquery-ui', plugins_url( 'wptuts-countdowner/css/jquery-ui-fresh.css' ) );
	
	} // end register_admin_styles

	/**
	 * Registers and enqueues admin-specific JavaScript.
	 */	
	public function register_admin_scripts() {

		wp_enqueue_script( 'jquery-ui-datepicker' );	
		// TODO:	Change 'wptuts-countdowner' to the name of your plugin
		wp_enqueue_script( 'wptuts-countdowner-admin-script', plugins_url( 'wptuts-countdowner/js/admin.js' ) );
		
	} // end register_admin_scripts
	
} // end class

// TODO:	Remember to change 'Wptuts_Countdowner' to match the class name definition
add_action( 'widgets_init', create_function( '', 'register_widget("Wptuts_Countdowner");' ) ); 